package gov.anl.aps.dm.portal.controllers;

import gov.anl.aps.dm.portal.exceptions.DmPortalException;
import gov.anl.aps.dm.portal.exceptions.MissingProperty;
import gov.anl.aps.dm.portal.exceptions.ObjectAlreadyExists;
import gov.anl.aps.dm.portal.model.entities.ExperimentPolicy;
import gov.anl.aps.dm.portal.model.beans.ExperimentPolicyFacade;
import java.util.List;

import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.SessionScoped;
import org.apache.log4j.Logger;

@Named("experimentPolicyController")
@SessionScoped
public class ExperimentPolicyController extends CrudEntityController<ExperimentPolicy, ExperimentPolicyFacade>
{

    private static final Logger logger = Logger.getLogger(ExperimentPolicyController.class.getName());

    @EJB
    private ExperimentPolicyFacade experimentPolicyFacade;

    public ExperimentPolicyController() {
    }

    @Override
    protected ExperimentPolicyFacade getFacade() {
        return experimentPolicyFacade;
    }

    @Override
    protected ExperimentPolicy createEntityInstance() {
        return new ExperimentPolicy();
    }

    @Override
    public String getEntityTypeName() {
        return "experimentPolicy";
    }

    @Override
    public String getCurrentEntityInstanceName() {
        return "";
    }

    @Override
    public List<ExperimentPolicy> getAvailableItems() {
        return super.getAvailableItems();
    }

    @Override
    public String prepareEdit(ExperimentPolicy experimentPolicy) {
        return super.prepareEdit(experimentPolicy);
    }

    @Override
    public void prepareEntityInsert(ExperimentPolicy experimentPolicy) throws ObjectAlreadyExists, MissingProperty {
        logger.debug("Inserting new experiment policy ");
    }

    @Override
    public void prepareEntityUpdate(ExperimentPolicy experimentPolicy) throws DmPortalException {
    }
    
      @Override
     protected String getObjectAlreadyExistMessage(ExperimentPolicy experimentPolicy)  {
        if (experimentPolicy == null) {
            return null;
        }
        return "Experiment Policy " + " already exists."; 
    }

}